int level; //determines laser placement and background color
float bgFill; //background color variable
PFont font;
Hero hero;
Gui levelOne;
Gui levelTwo;
Gui levelThree;
LaserBeam [] beams = new LaserBeam[6];

void setup() {
  size(800, 400);
  font = loadFont("ACaslonPro-Bold-32.vlw");
  level = 0;

  hero = new Hero();

  levelOne = new Gui(1, 90);
  levelTwo = new Gui(2, 60);
  levelThree = new Gui(3, 30);

  for (int i = 0; i < beams.length; i++) { //fill array with 5 laser beams
    beams[i] = new LaserBeam(40);
  }
}

void draw() {
  background(200);

  bgColorChange(); 
  levelAdvance();

  switch(level) { // laser placement depending on level
  case 0:
    beams[0].display(width * 0.5);
    break;
  case 1:
    beams[1].display(width * 0.66);
    beams[2].display(width * 0.33);
    break;
  case 2:
    beams[3].display(width * 0.75);
    beams[4].display(width * 0.5);
    beams[5].display(width * 0.25);
    break;
  default:
    youWin();
    break;
  } 
  
  hero.display(); //player character
  
  levelOne.display(); //gui
  levelTwo.display();
  levelThree.display();
}

void levelAdvance() { 
  if ((hero.x + hero.r) > width) { //reaching the right side advances to next level
    hero.x = 0;
    level++;
  }
}

void bgColorChange() { 
  noStroke();

  bgFill = map(hero.x, 0, width, 0, 255); //progressing through level changes background color

  if (level == 0) {
    fill(242, 224, 86, bgFill); //gold
  } else if (level == 1) { 
    fill(148, 245, 244, bgFill); //cyan
  } else if (level == 2) { 
    fill(255, 121, 121, bgFill); //magenta
  } else {
    fill(200);
  }
  //drawing a rectangle over background that changes color, since background() does not have an alpha option
  rect(0, 0, width, height);
}

void youWin() {
  hero.x = constrain(hero.x,0,width/2); //stops character at middle 
  
  fill(beams[0].beamDenied); //red; reusing color variable
  textFont(font,32);
  textSize(32);
  text("Well, I'm sure you're quite proud of yourself.", width * 0.1, height * 0.75);
}
  

