class LaserBeam { 
  float x;
  float y;
  float w;
  float h;
  float distance;
  int beamCycleAscend;
  int beamCycleTotal;
  color beamColor;
  color beamGranted;
  color beamDenied;

  LaserBeam(int beamWidth) { 
    x = 0;
    y = 0;
    w = beamWidth;
    h = height;

    beamGranted = color(85, 216, 79); //green
    beamDenied = color(160, 34, 34); //red

    beamCycleAscend = 0; //ascending modulo variable
    beamCycleTotal = 100; //modulo total
  }

  void colorChange() { 
    if (beamCycleAscend < beamCycleTotal/2) { //between 1 - 49 = green
      beamColor = beamGranted;
    } else if (beamCycleAscend > beamCycleTotal/2) { // between 49 - 100 = red
      beamColor = beamDenied;
    }
    //climbs to 100 then repeats
    beamCycleAscend = (beamCycleAscend + 1) % beamCycleTotal; 
  }

  void heroDeath() { 
    distance = dist(hero.x, hero.y, x + (w/2), height/2); // distance between center points of circle and rect
    if (beamColor == beamDenied) { // if beam is red
      if (distance <= w) {
        hero.x = 0;
      }
    }
  } 
  void display(float xPos) { 
    x = xPos;

    colorChange();
    heroDeath();

    noStroke();
    fill(beamColor); //color of beam indicates life or death
    rect(x, y, w, h);
  }
}

